import javax.swing.*;
import java.util.*;

/**
 * A Dialouge box showing statistics about the simulation
 * 
 * WARNING!!! Only read if you have a good understanding of Swing.
 * 
 * @author TriMill
 * @version 1.0.1
 */
public class InfoDialouge extends JFrame
{
    /**
     * Label for the number of creatures
     */
    private JLabel numCreatures = new JLabel("");
    /**
     * Label for the number of food pieces
     */
    private JLabel numFood = new JLabel("");
    /**
     * Label for the number of eggs
     */
    private JLabel numEggs = new JLabel("");
    /**
     * Label for the average speed of the creatures
     */
    private JLabel aveSpeed = new JLabel("");
    /**
     * Label for the average size of the creatures
     */
    private JLabel aveSize = new JLabel("");
    /**
     * Label for the number of mutations
     */
    private JLabel numMutations = new JLabel("");
    /**
     * Label for the number of reproductions
     */
    private JLabel numReproductions = new JLabel("");
    
    /**
     * Create a new statistic-showing popup box
     */
    public InfoDialouge()
    {
        setVisible(true);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        addComponents();
    }
    
    /**
     * Adds all of the labels to the popup box
     */
    private void addComponents()
    {
        JPanel p = new JPanel();
        p.add(numCreatures);
        p.add(numFood);
        p.add(numEggs);
        p.add(aveSpeed);
        p.add(aveSize);
        p.add(numMutations);
        p.add(numReproductions);
        add(p);
    }
    
    /**
     * Updates the popup to show new information
     */
    public void update()
    {
        Earth e = Earth.getMe();
        numCreatures.setText("Number of Creatures: " + e.countCreatures() + "    ");
        numEggs.setText("Number of Eggs: " + e.countEggs() + "    ");
        numFood.setText("Number of Food Pieces: " + e.countFood() + "    ");
        double averageS = 0;
        List cList = e.getObjects(Creature.class);
        for(Object c: cList)
        {
            averageS = averageS + ((Creature)c).getDNA().getSpeed();
        }
        averageS = averageS / e.countCreatures();
        averageS = Math.round(averageS*100.0)/100.0;
        aveSpeed.setText("Average speed: " + averageS + "    ");
        averageS = 0;
        for(Object c: cList)
        {
            averageS = averageS + ((Creature)c).getDNA().getSize();
        }
        averageS = averageS / e.countCreatures();
        averageS = Math.round(averageS*100.0)/100.0;
        aveSize.setText("Average size: " + averageS + "    ");
        numMutations.setText("Number of Mutations: " + CreatureDNA.getMutations() + "    ");
        numReproductions.setText("Number of Reproductions: " + CreatureDNA.getReproductions() + "    ");
    }
}









